<?php
/**
*  Conexiaweb.es
*  @author conexiaweb.es <info@conexiaweb.es>
*  @copyright  2020  Conexiaweb.es
*  @license    http://conexiaweb.es
*  Great!!!    http://transfertomalaga.es | http://transfertocordoba.es | http://transfertomarbella.com/ | http://transfervalladolid.es/ | http://transfertosevilla.es/ | http://transfertogranada.es/ | http://transfertorremolinos.es/ | http://transferfuengirola.es/ | http://transferbenalmadena.es/ | http://transfertomarbella.com/ | http://transfertonerja.es/ | http://transfertomijas.es/ | http://transfertorredelmar.es/ | http://laborser.es | http://multiserviciosencordoba.es
*/

if (!defined("_PS_VERSION_"))
    exit;
class Npersonalizado extends Module
{
    public function __construct()
    {
        $this->name = "npersonalizado";
        $this->tab = "administration";
        $this->version = "1.1.1";
        $this->author = "Conexiaweb";
        $this->need_instance = 1;
        $this->bootstrap = 1;
        $this->module_key = 'd40f7afd26c6b01ddd7f3051c959ef8a';
        parent::__construct();
        $this->displayName = $this->l('Numeración personalizada');
        $this->description = $this->l('Personaliza, número de factura, referencia de pedido y número de albarán de envío');

        $this->ps_versions_compliancy = array('min' => '1.6.0.0', 'max' => _PS_VERSION_);
    }
    public function install()
    {
        if (Shop::isFeatureActive()){
            Shop::setContext(Shop::CONTEXT_ALL);
        }
        return parent::install()
            && $this->_createTables()
            && $this->_createTab()
            && $this->registerHook('displayBackOfficeHeader')
            && $this->registerHook('actionObjectOrderAddAfter')
            && $this->registerHook('actionOrderStatusPostUpdate')
            && $this->registerHook('actionOrderStatusUpdate')
            && $this->registerHook('actionSetInvoice')
            && $this->registerHook('actionInvoiceNumberFormatted')
            && $this->registerHook('displayGDeliveryNumberFormatted')
            && $this->registerHook('actionAdminControllerSetMedia')
            && $this->fixViewCustomizeNumberInTpl(true)
            ;
    }
    public function uninstall()
    {
        return parent::uninstall()
            && $this->_deleteTables()
            && $this->_deleteTab()
            && $this->unregisterHook("displayBackOfficeHeader")
            && $this->unregisterHook("actionObjectOrderAddAfter")
            && $this->unregisterHook("actionOrderStatusPostUpdate")
            && $this->unregisterHook("actionOrderStatusUpdate")
            && $this->unregisterHook("actionSetInvoice")
            && $this->unregisterHook("actionInvoiceNumberFormatted")
            && $this->unregisterHook("displayGDeliveryNumberFormatted")
            && $this->unregisterHook("actionAdminControllerSetMedia")
            && $this->fixViewCustomizeNumberInTpl(false)
            ;
    }
    private function _createTables(){
        $response = Db::getInstance()->execute('
            CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'conexcustomnumber` (
                `id_conexcustomnumber` int(10) unsigned AUTO_INCREMENT NOT NULL,
                `type` varchar(2) NULL,
                `start` int(10) unsigned NOT NULL,
                `step` int(10) unsigned NOT NULL,
                `length` int(10) unsigned NOT NULL,
                `numberformat` varchar(255) NULL,
                `groups` varchar(255) NULL,
                `resettype` int(1) unsigned NOT NULL,
                `resetnumber` int(10) NULL,
                `resetdate` date NULL,
                `id_shop` int(10) unsigned NOT NULL,
                `current_counter_nbr` int(10) NULL DEFAULT  "0",
                PRIMARY KEY (`id_conexcustomnumber`)
            ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
        ');
        // from version 1.0.1
        $response &= Db::getInstance()->execute('
            CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'conexcnrandom` (
            	`id_conexcnrandom` INT(10) UNSIGNED AUTO_INCREMENT NOT NULL,
                `type` varchar(2) NULL,
            	`id_object` INT(10) UNSIGNED NOT NULL,
                `id_shop` int(10) unsigned NOT NULL,
                `random` varchar(255) NULL,
                `random_number` varchar(255) NULL,
            	PRIMARY KEY (`id_conexcnrandom`)
            ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;');

        //custom order reference
        $response &= Db::getInstance()->execute('ALTER TABLE `' . _DB_PREFIX_ . 'orders` MODIFY `reference` VARCHAR(32);');
        $response &= Db::getInstance()->execute('ALTER TABLE `' . _DB_PREFIX_ . 'order_payment` MODIFY `order_reference` VARCHAR(32)');
        return $response;
    }
    public function fixViewCustomizeNumberInTpl($install = true){
        $tpl_files = array(
            array(
                'file'=>'_documents.tpl',
                'changes'=>array(
                                array(
                                    'old'=>'{Configuration::get(\'PS_DELIVERY_PREFIX\', $current_id_lang, null, $order->id_shop)}{\'%06d\'|sprintf:$document->delivery_number}',
                                    'new'=>'{hook h=\'displayGDeliveryNumberFormatted\' number=$document->delivery_number obj=$document}'
                                ),
                                array(
                                    'old'=>'#{Configuration::get(\'PS_DELIVERY_PREFIX\', $current_id_lang)}{\'%06d\'|sprintf:$document->delivery_number}',
                                    'new'=>'{hook h=\'displayGDeliveryNumberFormatted\' number=$document->delivery_number obj=$document}'
                                )
                    )
            ),
            array(
                'file'=>'_product_line.tpl',
                'changes'=>array(
                                array(
                                    'old'=>'#{Configuration::get(\'PS_INVOICE_PREFIX\', $current_id_lang, null, $order->id_shop)}{\'%06d\'|sprintf:$invoice->number}',
                                    'new'=>'{$invoice->getInvoiceNumberFormatted($current_id_lang, $order->id_shop)}'
                                ),
                                array(
                                    'old'=>'#{Configuration::get(\'PS_INVOICE_PREFIX\', $current_id_lang)}{\'%06d\'|sprintf:$invoice->number}',
                                    'new'=>'{$invoice->getInvoiceNumberFormatted($current_id_lang, $order->id_shop)}'
                                )
                    )
            ),
            array(
                'file'=>'order-confirmation.tpl',
                'isfront'=>1,
                'changes'=>array(
                                array(
                                    'old'=>'{$id_order_formatted}',
                                    'new'=>'{$reference_order}'
                                )
                    )
            )

        );


        foreach($tpl_files as $tpl_file){
            $tpl_path = _PS_BO_ALL_THEMES_DIR_.'default'.DIRECTORY_SEPARATOR.'template'.DIRECTORY_SEPARATOR.'controllers'.DIRECTORY_SEPARATOR.'orders'.DIRECTORY_SEPARATOR;
            $file_name = $tpl_file['file'];
            if(isset($tpl_file['isfront']) && $tpl_file['isfront'] == 1) $tpl_path = _PS_THEME_DIR_;
            if (Tools::file_exists_cache($tpl_path.$file_name)) {
                if($install){
                    //backup file
                    copy($tpl_path.$file_name, $tpl_path.$file_name.'.bk');
                    //get content
                    $content = Tools::file_get_contents($tpl_path.$file_name);
                    //change data
                    foreach ($tpl_file['changes'] as $change) {
                        $content = str_replace($change['old'], $change['new'], $content);
                    }
                    //save data
                    file_put_contents($tpl_path.$file_name, $content);
                }
                else{
                    //check backup file exist
                    if (Tools::file_exists_cache($tpl_path.$file_name.'.bk')) {
                        //backup file
                        copy($tpl_path.$file_name, $tpl_path.$file_name.'.bk_'.time());
                        //get backup content
                        $content = Tools::file_get_contents($tpl_path.$file_name.'.bk');
                        //save data
                        file_put_contents($tpl_path.$file_name, $content);
                        //remove backup file
                        @unlink($tpl_path.$file_name.'.bk');
                    }
                }
                // Clear compiled
                Context::getContext()->smarty->clearCompiledTemplate();
            }
        }
        return true;
    }
    public function hookActionSetInvoice($params){
        if(isset($params['OrderInvoice']) && Validate::isLoadedObject($params['OrderInvoice'])){
            $object = $params['OrderInvoice'];
            $this->customizeNumber('I',$object);
        }
    }
    public function hookActionOrderStatusUpdate($params){
        $new_os = $params['newOrderStatus'];
        if ($new_os->delivery) {
            $id_order = (int)$params['id_order'];
            $order = new Order($id_order);
            if(Validate::isLoadedObject($order)){
                $active_custom_number = (bool)Configuration::get('CUS_DELIVERY_ACTIVE',null,null,(int)$order->id_shop);
                if($active_custom_number){
                    $order_invoice_collection = $order->getInvoicesCollection();
                    foreach ($order_invoice_collection as $order_invoice) {
                        if ($order_invoice->delivery_number) {
                            continue;
                        }
                        $this->customizeNumber('D',$order_invoice);
                        $delivery_number = (int)$order->getDeliveryNumber($order_invoice->id);
                        Configuration::updateValue('PS_DELIVERY_NUMBER_'.(int)$order_invoice->id,$delivery_number, false, null, $order->id_shop);
                    }
                }
            }
        }
    }
    public function hookActionInvoiceNumberFormatted($params){
        if(isset($params['OrderInvoice']) && Validate::isLoadedObject($params['OrderInvoice'])){
            $number =  $this->formatNumber('I',$params['number'],$params['OrderInvoice']);
             return $number;
        }
    }
    public function hookDisplayGDeliveryNumberFormatted($params)
    {
        $number = (int)$params['number'];
        $OrderInvoiceobj = $params['obj'];
        if(Validate::isLoadedObject($OrderInvoiceobj) && get_class($OrderInvoiceobj) == 'OrderInvoice'){
            return $this->formatNumber('D',$number,$OrderInvoiceobj);
        }
    }
    public function hookActionObjectOrderAddAfter($params)
    {
        $this->customizeNumber('O',$params['object']);
    }
    public function hookActionOrderStatusPostUpdate($params){
        $id_order = (int)$params['id_order'];
        $orderObj = new Order((int)$id_order);
        if(Validate::isLoadedObject($orderObj)){
            $sql = 'UPDATE `' . _DB_PREFIX_ . 'order_payment` SET order_reference = "'.pSql($orderObj->reference).'"
                    WHERE id_order_payment IN (
                        SELECT id_order_payment
                        FROM `' . _DB_PREFIX_ . 'order_invoice_payment`
                        WHERE id_order = '.(int)$id_order.'
                    )';
            Db::getInstance()->execute($sql);
            if(isset($params['newOrderStatus'])){
                $new_os = $params['newOrderStatus'];
                if ($new_os->delivery) {
                    $active_custom_number = (bool)Configuration::get('CUS_DELIVERY_ACTIVE',null,null,(int)$orderObj->id_shop);
                    if($active_custom_number){
                        $order_invoice_collection = $orderObj->getInvoicesCollection();
                        $order_invoice_date = date('Y-m-d H:i:s');
                        foreach ($order_invoice_collection as $order_invoice) {
                            $number = Configuration::get('PS_DELIVERY_NUMBER_'.$order_invoice->id, null, null, $orderObj->id_shop);
                            if($number > 0){
                                $orderObj->delivery_number = (int)$number;
                                Configuration::deleteByName('PS_DELIVERY_NUMBER_'.$order_invoice->id);
                            }
                            else{
                                $this->customizeNumber('D',$order_invoice);
                                $orderObj->delivery_number = $orderObj->getDeliveryNumber($order_invoice->id);
                            }

                            $order_invoice_date = date('Y-m-d H:i:s',strtotime($order_invoice->delivery_date));
                        }
                        $orderObj->delivery_date = $order_invoice_date;
                        $orderObj->update();
                    }
                }
            }
        }
    }
    public function hookDisplayBackOfficeHeader($params){
        $this->context->controller->addCss($this->_path.'/views/css/admin/npersonalizado.css');
    }
    public function customizeNumber($type,$itemObj,$test = false){
        $id_shop = $this->context->shop->id;
        $customer_group = '';
        $numberconfig = array();
        if(!$test){
            $orderObj = $itemObj;
            if($type == 'I' || $type == 'D')
                $orderObj = new Order($itemObj->id_order);
                //$orderObj = $itemObj->getOrder(); // mising function from ps 1.6.0.14
            $id_customer = (int)$orderObj->id_customer;
            $id_shop = (int)$orderObj->id_shop;
            // get number config
            $customer_group = (int)Customer::getDefaultGroupId($id_customer);
            $sql = 'SELECT * FROM `' . _DB_PREFIX_ . 'conexcustomnumber` c WHERE FIND_IN_SET('.pSQL($customer_group).',groups) AND c.type="'.pSql($type).'" AND c.id_shop = '.(int)$id_shop;
            $numberconfig =  Db::getInstance()->getRow($sql);
        }else{
            $numberconfig['start'] = Tools::getValue('start');
            $numberconfig['step'] = Tools::getValue('step');
            $numberconfig['current_counter_nbr'] = Tools::getValue('current');
            $assign_group = Tools::getValue('groupBox_'.Tools::getValue('type_rule'));
            $_assign_group = array();
            if(is_array($assign_group))
                $_assign_group = array_map('intval', $assign_group);
            // get first customer group
            if($_assign_group)
                foreach($_assign_group as $_group){$customer_group = (int)$_group;break;}
            else return array();
            $numberconfig['groups'] = implode(',',$_assign_group);
            $numberconfig['resettype'] = Tools::getValue(Tools::getValue('type_rule').'_reset');
            $numberconfig['resetnumber'] = Tools::getValue('resetnumber');
            $numberconfig['resetdate'] = Tools::getValue('resetdate');
            $numberconfig['numberformat'] = Tools::getValue('numberformat');
            $numberconfig['length'] = Tools::getValue('length');


        }
        $shop_group_id = (int)Shop::getGroupFromShop($id_shop, true);

        $config_key = '';
        if($type == 'I'){
            $config_key = 'INVOICE';
        }elseif($type == 'D'){
            $config_key = 'DELIVERY';
        }elseif($type == 'O'){
            $config_key = 'ORDER';
        }
        $active_custom_number = true;
        if(!$test)
            $active_custom_number = (bool)Configuration::get('CUS_'.$config_key.'_ACTIVE',null,null,(int)$id_shop);
        if($numberconfig && isset($numberconfig['numberformat']) && trim($numberconfig['numberformat']) !=''  && $active_custom_number){
            // if have rule
            $start = (int)$numberconfig['start'];if($start < 1) $start = 1;
            $step = (int)$numberconfig['step'];if($step < 1) $step = 1;
            // get last id

            $old_reset_date_old = Configuration::get('GAI_RESET_DATE_'.$type.'_'.(int)$customer_group, null, $shop_group_id, $id_shop);
            $old_reset_date = $old_reset_date_old;
            if($old_reset_date == '' || $old_reset_date == '0000-00-00'){
                $old_reset_date = '1970-01-01 00:00:00'; // Unix timestamp
            }
            switch ((int)$numberconfig['resettype']) {
                case '0':
                    $old_reset_date = '1970-01-01 00:00:00'; // Unix timestamp
                    break;
                case '2':
                    // reset every day
                    $day_now = date('Y-m-d');
                    $old_reset_date = $day_now.' 00:00:00';
                    break;
                case '3':
                    // reset every month
                    $month_now = date('Y-m');
                    $old_reset_date = $month_now.'-01'.' 00:00:00';
                    break;
                case '4':
                    // reset every year
                    $year_now = date('Y');
                    $old_reset_date = $year_now.'-01'.'-01'.' 00:00:00';
                    break;
                case '5':
                    // reset by date
                    $time_reset_config = $numberconfig['resetdate'];
                    if($time_reset_config !=null && $time_reset_config !=''){
                        $time_reset = date('Y-m-d H:i:s',strtotime($time_reset_config));
                        $old_reset_date = $time_reset;
                    }else{
                        $old_reset_date = '1970-01-01 00:00:00'; // Unix timestamp
                    }
                    break;
            }
            if(!$test && $old_reset_date_old != $old_reset_date) {
                Configuration::updateValue('GAI_RESET_DATE_' . $type . '_' . (int)$customer_group, $old_reset_date, false, $shop_group_id, $id_shop);
                $sql = 'UPDATE `'._DB_PREFIX_.'conexcustomnumber` SET current_counter_nbr=0  WHERE id_conexcustomnumber = '.(int)$numberconfig['id_conexcustomnumber'];
                Db::getInstance()->Execute($sql);
                $sql = 'SELECT * FROM `' . _DB_PREFIX_ . 'conexcustomnumber` c WHERE FIND_IN_SET('.pSQL($customer_group).',groups) AND c.type="'.pSql($type).'" AND c.id_shop = '.(int)$id_shop;
                $numberconfig =  Db::getInstance()->getRow($sql);
            }
            $next_number = $numberconfig['current_counter_nbr'] + $step;
            $reset = (int)$numberconfig['resettype'];
            $number_reset = 0;
            if($reset == 1)
                if($numberconfig['resetnumber'] > 1)
                    $number_reset = (int)$numberconfig['resetnumber'];
            if($next_number < $start || $numberconfig['current_counter_nbr'] <= 0) $next_number = $start;
            if($reset == 1 && $next_number >= $number_reset && $number_reset > 0)
            {
                $next_number = $start;
                if(!$test) {
                    Configuration::updateValue('GAI_RESET_DATE_' . $type . '_' . (int)$customer_group, date('Y-m-d H:i:s'), false, $shop_group_id, $id_shop);
                }
            }
            if(!$test){
                // update custom number
                if($type == 'O'){
                    $orderObj->reference = $this->formatNumber($type,(int)$next_number,$orderObj);
                    $orderObj->save();
                }elseif($type == 'I'){
                    $itemObj->number = (int)$next_number;
                    $itemObj->save();
                }elseif($type == 'D'){
                    $itemObj->delivery_number = (int)$next_number;
                    $itemObj->save();
                }
                $sql = 'UPDATE `'._DB_PREFIX_.'conexcustomnumber` SET current_counter_nbr= '.(int)$next_number.' WHERE id_conexcustomnumber = '.(int)$numberconfig['id_conexcustomnumber'];
                Db::getInstance()->Execute($sql);
                return true;
            }else {
                $numberconfig['customer_group'] = $customer_group;
                $numberconfig['next_number'] = $next_number;
                return $numberconfig;
            }
        }else return false;
    }
    public function hookActionAdminControllerSetMedia($params)
    {
        $controller = Tools::getValue('controller');
        if ($controller == 'Adminconexcustomnumber') {
            $this->context->controller->addCss($this->_path.'/views/css/admin/npersonalizado.css');
            $this->context->controller->addJqueryPlugin('datepicker');
            $this->context->controller->addJS(_PS_MODULE_DIR_.$this->name.'/views/js/admin/customnumberconex.js');
        }
    }
    public function getTotal($type,$groups,$old_reset_date,$id_shop){
        $sql = '';
        if($type == 'O'){
            $sql = 'SELECT COUNT(id_order) FROM `' . _DB_PREFIX_ . 'orders` o
                    LEFT JOIN `' . _DB_PREFIX_ . 'customer` c ON(o.id_customer = c.id_customer)
                    WHERE  FIND_IN_SET(c.id_default_group,"'.pSql($groups).'") AND o.date_add >="'.pSql($old_reset_date).'" '
                    .' AND o.id_shop = '.(int)$id_shop;
        }else{
            $number_column = 'number';
            if($type == 'D') $number_column = 'delivery_number';
            $sql = 'SELECT COUNT(id_order_invoice) FROM `' . _DB_PREFIX_ . 'order_invoice` oi
                    INNER JOIN ' . _DB_PREFIX_ . 'orders o ON(o.id_order = oi.id_order)
                    LEFT JOIN `' . _DB_PREFIX_ . 'customer` c ON(o.id_customer = c.id_customer)
                    WHERE  FIND_IN_SET(c.id_default_group,"'.pSql($groups).'")
                    AND (oi.'.pSql($number_column).' <> 0 AND TRIM(IFNULL(oi.'.pSql($number_column).',"")) <> "")
                    AND oi.date_add >="'.pSql($old_reset_date).'" '
                    .' AND o.id_shop = '.(int)$id_shop;

        }
        return (int)Db::getInstance()->getValue($sql);
    }
    public function formatNumber($type,$number,$itemObj,$test=false,$testdata = array()){

        $date_add = date('Y-m-d');
        $id_lang = (int)$this->context->language->id;
        $id_shop = (int)$this->context->shop->id;
        $id_shop_group = Shop::getContextShopGroupID();
        $customer_group = 0;
        $numberconfig = array();
        if($test){
            $numberconfig = $testdata;
            $customer_group = (int)$numberconfig['customer_group'];
        }else{

            $date_add = $itemObj->date_add;
            if($type == 'D'){

                if($date_add == '0000-00-00 00:00:00' || $date_add == ''){
                    $itemObj2 = new OrderInvoice($itemObj->id);
                    $date_add = $itemObj2->date_add;
                }
                //
            }

            $orderObj = $itemObj;
            if($type == 'I' || $type == 'D') $orderObj = $itemObj->getOrder();
            $id_customer = (int)$orderObj->id_customer;
            // get number config
            $customer_group = (int)Customer::getDefaultGroupId($id_customer);
            $sql = 'SELECT * FROM `' . _DB_PREFIX_ . 'conexcustomnumber` c WHERE FIND_IN_SET('.pSQL($customer_group).',groups) AND c.type="'.pSql($type).'" AND c.id_shop = '.(int)$orderObj->id_shop;
            $numberconfig =  Db::getInstance()->getRow($sql);
            $id_shop = (int)$orderObj->id_shop;
            $id_lang = (int)$orderObj->id_lang;
        }
        $config_key = '';
        if($type == 'I'){
            $config_key = 'INVOICE';
        }elseif($type == 'D'){
            $config_key = 'DELIVERY';
        }elseif($type == 'O'){
            $config_key = 'ORDER';
        }
        $active_custom_number = true;
        if(!$test)
            $active_custom_number = (bool)Configuration::get('CUS_'.$config_key.'_ACTIVE',null,null,(int)$id_shop);
        if($numberconfig && $active_custom_number){
            // get fomart
            $number_format = $numberconfig['numberformat'];






            $length = (int)$numberconfig['length'];if($length < 2) $length = 2;
            $matches = array();
            preg_match_all('/\{(.*?)\}/', $number_format, $matches);
            if(isset($matches[0]) && $matches[0]){
                foreach($matches[0] as $shortcode)
                {
                    $data_shortcode = '';
                    switch ($shortcode) {
                        case '{dd}':
                        case '{DD}':
                            $data_shortcode = date('d',strtotime($date_add));
                            break;
                        case '{d}':
                        case '{D}':
                            $data_shortcode = date('j',strtotime($date_add));
                            break;
                        case '{mm}':
                        case '{MM}':
                            $data_shortcode = date('m',strtotime($date_add));
                            break;
                        case '{m}':
                        case '{M}':
                            $data_shortcode = date('n',strtotime($date_add));
                            break;
                        case '{yy}':
                        case '{YY}':
                            $data_shortcode = date('Y',strtotime($date_add));
                            break;
                        case '{y}':
                        case '{Y}':
                            $data_shortcode = date('y',strtotime($date_add));
                            break;
                        case '{id_customer}':
                        case '{ID_CUSTOMER}':
                            if($test) $data_shortcode = 1; else $data_shortcode = (int)$id_customer;
                            break;
                        case '{id_group}':
                        case '{ID_GROUP}':
                            $data_shortcode = (int)$customer_group;
                            break;
                        case '{id_shop}':
                        case '{ID_SHOP}':
                            $data_shortcode = (int)$id_shop;
                            break;
                        case '{group}':
                        case '{GROUP}':
                            $groupObj = new Group((int)$customer_group,(int)$id_lang,(int)$id_shop);
                            $data_shortcode = Tools::strtoupper($groupObj->name);
                            break;
                        case '{counter}':
                        case '{COUNTER}':
                            $data_shortcode = str_pad($number,$length,0,STR_PAD_LEFT);
                            break;
                        case '{id_order}':
                        case '{ID_ORDER}':
                            if(!$test)
                                $data_shortcode = $orderObj->id;
                            else{
                                //get next id_order
                                $sql = 'SELECT MAX(id_order)+1 FROM '._DB_PREFIX_.'orders';
                                $data_shortcode = (int)Db::getInstance()->getValue($sql);
                            }
                            break;
                        case '{order_reference}':
                        case '{ORDER_REFERENCE}':
                            if(!$test){
                                if($type == 'I' || $type == 'D')
                                    $data_shortcode = $orderObj->reference;
                            }else{
                                $data_shortcode = Order::generateReference();
                            }
                            break;
                        case '{id_invoice}':
                        case '{ID_INVOICE}':
                            if(!$test){
                                if($type == 'I' || $type == 'D')
                                    $data_shortcode = $itemObj->id;
                            }else{
                                // get next id_invoice
                                $sql = 'SELECT MAX(id_order_invoice)+1 FROM '._DB_PREFIX_.'order_invoice';
                                $data_shortcode = (int)Db::getInstance()->getValue($sql);
                            }
                            break;
                        case '{random}':
                        case '{RANDOM}':
                            $RANDOM_LENGTH = (int)Configuration::get('GAI_CUSTOMNUMBER_RANDOM_LENGTH', null, $id_shop_group, $id_shop);
                            $RANDOM_NUMBER_LENGTH = (int)Configuration::get('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', null, $id_shop_group, $id_shop);
                            $RANDOM_ALL = (int)Configuration::get('GAI_CUSTOMNUMBER_RANDOM_ALL', null, $id_shop_group, $id_shop);
                            if($RANDOM_LENGTH <=0 || $RANDOM_LENGTH >8) $RANDOM_LENGTH = 8;
                            if($RANDOM_NUMBER_LENGTH <=0 || $RANDOM_NUMBER_LENGTH >8) $RANDOM_NUMBER_LENGTH = 8;
                            if($test){
                                $data_shortcode = Tools::strtoupper(Tools::passwdGen($RANDOM_LENGTH, 'NO_NUMERIC'));//Order::generateReference();
                            }else{
                                if (version_compare($this->version, '1.0.0', '>')){
                                    // add to conexcnrandom table
                                    $old_type = $type;
                                    if($RANDOM_ALL) $type = 'O';
                                    $sql = 'SELECT random FROM `'._DB_PREFIX_.'conexcnrandom`
                                        WHERE type="'.pSql($type).'" AND id_object = '.(($type == 'I' || $type == 'D') ? (int)$itemObj->id : (int)$orderObj->id).' AND id_shop = '.(int)$id_shop.'
                                    ';
                                    $random_number = Db::getInstance()->getValue($sql);
                                    if($random_number)
                                        $data_shortcode = $random_number;
                                    else{
                                        $data_shortcode = Tools::strtoupper(Tools::passwdGen($RANDOM_LENGTH, 'NO_NUMERIC'));//Order::generateReference();
                                        $max_nbr = pow(10,$RANDOM_NUMBER_LENGTH)-1;
                                        $data_shortcode2 = (int)rand(0,$max_nbr);
                                        if($RANDOM_ALL) $type = 'O';
                                        $sql = 'INSERT INTO `'._DB_PREFIX_.'conexcnrandom`(type,id_object,id_shop,random_number,random)
                                            VALUES("'.pSQL($type).'",'.(int)(($type == 'I' || $type == 'D') ? (int)$itemObj->id : (int)$orderObj->id).','.(int)$id_shop.','.(int)$data_shortcode2.',"'.pSQL($data_shortcode).'")';
                                        Db::getInstance()->execute($sql);
                                    }
                                    $type = $old_type;
                                }else{
                                    $data_shortcode = Tools::strtoupper(Tools::passwdGen($RANDOM_LENGTH, 'NO_NUMERIC'));//Order::generateReference();
                                }
                            }
                            break;
                        case '{random_number}':
                        case '{RANDOM_NUMBER}':
                            $RANDOM_LENGTH = (int)Configuration::get('GAI_CUSTOMNUMBER_RANDOM_LENGTH', null, $id_shop_group, $id_shop);
                            $RANDOM_NUMBER_LENGTH = (int)Configuration::get('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', null, $id_shop_group, $id_shop);
                            $RANDOM_NUMBER_ALL = (int)Configuration::get('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', null, $id_shop_group, $id_shop);
                            if($RANDOM_LENGTH <=0 || $RANDOM_LENGTH >8) $RANDOM_LENGTH = 8;
                            if($RANDOM_NUMBER_LENGTH <=0 || $RANDOM_NUMBER_LENGTH >8) $RANDOM_NUMBER_LENGTH = 8;
                            $max_nbr = pow(10,$RANDOM_NUMBER_LENGTH)-1;
                            if($test){
                                $data_shortcode = (int)rand(0,$max_nbr);
                            }else{
                                if (version_compare($this->version, '1.0.0', '>')){
                                    // add to conexcnrandom table
                                    $old_type = $type;
                                    if($RANDOM_NUMBER_ALL) $type = 'O';
                                    $sql = 'SELECT random_number FROM `'._DB_PREFIX_.'conexcnrandom`
                                        WHERE type="'.pSql($type).'" AND id_object = '.(($type == 'I' || $type == 'D') ? (int)$itemObj->id : (int)$orderObj->id).' AND id_shop = '.(int)$id_shop.'
                                    ';
                                    $random_number = Db::getInstance()->getValue($sql);
                                    if($random_number)
                                        $data_shortcode = (int)$random_number;
                                    else{
                                        $data_shortcode = (int)rand(0,$max_nbr);
                                        $data_shortcode2 = Tools::strtoupper(Tools::passwdGen($RANDOM_LENGTH, 'NO_NUMERIC'));//Order::generateReference();
                                        $sql = 'INSERT INTO `'._DB_PREFIX_.'conexcnrandom`(type,id_object,id_shop,random_number,random)
                                            VALUES("'.pSQL($type).'",'.(int)(($type == 'I' || $type == 'D') ? (int)$itemObj->id : (int)$orderObj->id).','.(int)$id_shop.','.(int)$data_shortcode.',"'.pSQL($data_shortcode2).'")';
                                        Db::getInstance()->execute($sql);
                                    }
                                    $type = $old_type;
                                }else{
                                    $data_shortcode = (int)rand(0,$max_nbr);
                                }
                            }
                            break;

                    }
                    $number_format = str_replace($shortcode,$data_shortcode,$number_format);
                }
            }
            return $number_format;
        }else{
            // return default
            return Configuration::get('PS_' . $config_key . '_PREFIX', $id_lang, null, $id_shop)
                . sprintf('%06d', (int)$number);
        }

    }

    private function _deleteTables()
    {
        $_allgroup = Group::getGroups((int)$this->context->language->id,(int)$this->context->shop->id);
        if($_allgroup)
            foreach($_allgroup as $group){
                Configuration::deleteByName('GAI_RESET_DATE_O_'.(int)$group['id_group']);
                Configuration::deleteByName('GAI_RESET_DATE_I_'.(int)$group['id_group']);
                Configuration::deleteByName('GAI_RESET_DATE_D_'.(int)$group['id_group']);
            }
        return (bool)Db::getInstance()->execute('
                DROP TABLE IF EXISTS `' . _DB_PREFIX_ . 'conexcustomnumber`,`'._DB_PREFIX_.'conexcnrandom`;
        ');
    }
    private function _createTab()
    {
        $res = true;
        $tabparent = "Admininvoice";
        $id_parent = Tab::getIdFromClassName($tabparent);
        if(!$id_parent){
            $tab = new Tab();
            $tab->active = 1;
            $tab->class_name = "Admininvoice";
            $tab->name = array();
            foreach (Language::getLanguages() as $lang){
                $tab->name[$lang["id_lang"]] = "CONEXIAWEB";
            }
            $tab->id_parent = 0;
            $tab->module = $this->name;
            $res &= $tab->add();
            $id_parent = $tab->id;
        }
        $subtabs = array(
            array(
                'class'=>'Adminconexcustomnumber',
                'name'=>'Nº personalizado'
            ),
        );
        foreach($subtabs as $subtab){
            $idtab = Tab::getIdFromClassName($subtab['class']);
            if(!$idtab){
                $tab = new Tab();
                $tab->active = 1;
                $tab->class_name = $subtab['class'];
                $tab->name = array();
                foreach (Language::getLanguages() as $lang){
                    $tab->name[$lang["id_lang"]] = $subtab['name'];
                }
                $tab->id_parent = $id_parent;
                $tab->module = $this->name;
                $res &= $tab->add();
            }
        }
        return $res;
    }
    private function _deleteTab()
    {
        $id_tabs = array("Adminconexcustomnumber");
        foreach($id_tabs as $id_tab){
            $idtab = Tab::getIdFromClassName($id_tab);
            $tab = new Tab((int)$idtab);
            if(Validate::isLoadedObject($tab)){
                $parentTabID = $tab->id_parent;
                $tab->delete();
                $tabCount = Tab::getNbTabs((int)$parentTabID);
                if ($tabCount == 0){
                    $parentTab = new Tab((int)$parentTabID);
                    $parentTab->delete();
                }
            }
        }
        return true;
    }
    public function getContent(){
        if(Tools::isSubmit('saveCustomnumberConfig')){
            $shop_context = Shop::getContext();
            $shop_groups_list = array();
			$shops = Shop::getContextListShopID();

			foreach ($shops as $shop_id)
			{
				$shop_group_id = (int)Shop::getGroupFromShop($shop_id, true);

				if (!in_array($shop_group_id, $shop_groups_list))
					$shop_groups_list[] = $shop_group_id;

				$res = Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH'), false, $shop_group_id, $shop_id);
				$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH'), false, $shop_group_id, $shop_id);
				$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_ALL'), false, $shop_group_id, $shop_id);
				$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL'), false, $shop_group_id, $shop_id);
			}

			/* Update global shop context if needed*/
			switch ($shop_context)
			{
				case Shop::CONTEXT_ALL:
					$res = Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH'));
					$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH'));
					$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_ALL'));
					$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL'));
					if (count($shop_groups_list))
					{
						foreach ($shop_groups_list as $shop_group_id)
						{
							$res = Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH'), false, $shop_group_id);
							$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH'), false, $shop_group_id);
							$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_ALL'), false, $shop_group_id);
							$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL'), false, $shop_group_id);
						}
					}
					break;
				case Shop::CONTEXT_GROUP:
					if (count($shop_groups_list))
					{
						foreach ($shop_groups_list as $shop_group_id)
						{
							$res = Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH'), false, $shop_group_id);
							$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH'), false, $shop_group_id);
							$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_ALL'), false, $shop_group_id);
							$res &= Configuration::updateValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL'), false, $shop_group_id);
						}
					}
					break;
            }
            Tools::redirectAdmin($this->context->link->getAdminLink('AdminModules', true).'&conf=6&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name);
        }
        return $this->renderForm();
    }
    public function renderForm(){
        $fields_form = array(
			'form' => array(
                'legend' => array(
                    'title' => $this->l('Configuración general, si no quieres usar más opciones.'),
                    'icon' => 'icon-cogs'
                ),
                'input' => array(
                    array(
						'type' => 'text',
						'label' => $this->l('{RANDOM} Longitud de la cadena de letras aleatorias "EXGSTYUGJ"'),
						'name' => 'GAI_CUSTOMNUMBER_RANDOM_LENGTH',
                    ),
                    array(
						'type' => 'text',
						'label' => $this->l('Número máximo {RANDOM_NUMBER} de la cadena de números "0->999999"'),
						'name' => 'GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH',
                    ),
                    array(
						'type' => 'switch',
						'label' => $this->l('Usar {RANDOM} para facturas, referencias de pedido y albaranes de envío'),
						'name' => 'GAI_CUSTOMNUMBER_RANDOM_ALL',
						'values' => array(
							array(
								'id' => 'GAI_CUSTOMNUMBER_RANDOM_ALL_on',
								'value' => 1,
								'label' => $this->l('Enabled')
							),
							array(
								'id' => 'GAI_CUSTOMNUMBER_RANDOM_ALL_off',
								'value' => 0,
								'label' => $this->l('Disabled')
							)
						),
                    ),
                    array(
						'type' => 'switch',
						'label' => $this->l('Usar {RANDOM_NUMBER} para facturas, referencias de pedido y albaranes de envío'),
						'name' => 'GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL',
						'values' => array(
							array(
								'id' => 'GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL_on',
								'value' => 1,
								'label' => $this->l('Enabled')
							),
							array(
								'id' => 'GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL_off',
								'value' => 0,
								'label' => $this->l('Disabled')
							)
						),
					)
                ),
                'submit' => array(
                    'title' => $this->l('Save'),
                    'name' => 'saveCustomnumberConfig'
                )
            )
        );
        $helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table = $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$this->fields_form = array();
        $helper->module = $this;
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'saveCustomnumberConfig';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);
		return $helper->generateForm(array($fields_form));
    }
    public function getConfigFieldsValues(){
        $id_shop_group = Shop::getContextShopGroupID();
		$id_shop = Shop::getContextShopID();
		return array(
			'GAI_CUSTOMNUMBER_RANDOM_LENGTH' => (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_LENGTH', Configuration::get('GAI_CUSTOMNUMBER_RANDOM_LENGTH', null, $id_shop_group, $id_shop)),
            'GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH' => (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', Configuration::get('GAI_CUSTOMNUMBER_RANDOM_NUMBER_LENGTH', null, $id_shop_group, $id_shop)),
            'GAI_CUSTOMNUMBER_RANDOM_ALL' => (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_ALL', Configuration::get('GAI_CUSTOMNUMBER_RANDOM_ALL', null, $id_shop_group, $id_shop)),
            'GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL' => (int)Tools::getValue('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', Configuration::get('GAI_CUSTOMNUMBER_RANDOM_NUMBER_ALL', null, $id_shop_group, $id_shop)),
		);
    }
}
