<?php
/**
*  Conexiaweb.es
*  @author conexiaweb.es <info@conexiaweb.es>
*  @copyright  2020  Conexiaweb.es
*  @license    http://conexiaweb.es
*  Great!!!    http://transfertomalaga.es | http://transfertocordoba.es | http://transfertomarbella.com/ | http://transfervalladolid.es/ | http://transfertosevilla.es/ | http://transfertogranada.es/ | http://transfertorremolinos.es/ | http://transferfuengirola.es/ | http://transferbenalmadena.es/ | http://transfertomarbella.com/ | http://transfertonerja.es/ | http://transfertomijas.es/ | http://transfertorredelmar.es/ | http://laborser.es | http://multiserviciosencordoba.es
*/

class PDF extends PDFCore
{
    public function render($display = true)
    {
        if(Module::isInstalled('npersonalizado') && Module::isEnabled('npersonalizado')){
        $render = false;
        $this->pdf_renderer->setFontForLang(Context::getContext()->language->iso_code);
        foreach ($this->objects as $object) {
            $this->pdf_renderer->startPageGroup();
            $template = $this->getTemplateObject($object);
            if (!$template) {
                continue;
            }

            if (empty($this->filename)) {
                if (count($this->objects) > 1) {
                    $this->filename = $template->getBulkFilename();
                }else{
                    if(Module::isInstalled('npersonalizado') && Module::isEnabled('npersonalizado') && get_class($object) == 'OrderInvoice'){
    			         $invoiceObj = Module::getInstanceByName('npersonalizado');
                         $templatetype =  get_class($template);
                         if($templatetype == 'HTMLTemplateInvoice'){
                            $title = $invoiceObj->formatNumber('I',$template->order_invoice->number,$template->order_invoice);
                            $template->title = $title;
                            $this->filename = preg_replace('/[^A-Za-z0-9\-\.]/', '-', $title. '.pdf');
                         }elseif($templatetype == 'HTMLTemplateDeliverySlip'){
                            $title = $invoiceObj->formatNumber('D',$template->order_invoice->delivery_number,$template->order_invoice);
                            $template->title = $title;
                            $this->filename = preg_replace('/[^A-Za-z0-9\-\.]/', '-', $title. '.pdf');
                         }
    			    }else
    				    $this->filename = $template->getFilename();
                }
            }
            $template->assignHookData($object);

            $this->pdf_renderer->createHeader($template->getHeader());
            $this->pdf_renderer->createFooter($template->getFooter());
            $this->pdf_renderer->createPagination($template->getPagination());
            $this->pdf_renderer->createContent($template->getContent());
            $this->pdf_renderer->writePage();
            $render = true;

            unset($template);
        }

        if ($render) {
            // clean the output buffer
            if (ob_get_level() && ob_get_length() > 0) {
                ob_clean();
            }
            return $this->pdf_renderer->render($this->filename, $display);
        }
        }else{
            return parent::render($display);
        }
    }
}
?>